% Script for showing the different designs of the plant at different
% electricity and gas prices

% ------------------------------
run_new_simulation = 0;
plot_bargraphs = 0;
% ------------------------------

global running_energy_price_simulation;
running_energy_price_simulation = 1;
global electricity_price_iter;
global gas_price_iter;
global elprice_constant;
global gasprice_constant;

steps = 8;

elprice_mid = elprice_constant;
gasprice_mid = gasprice_constant;
elprice_low = elprice_constant*0.5;
elprice_high = elprice_constant*1.5;
gasprice_low = gasprice_constant*0.5;
gasprice_high = gasprice_constant*1.5;
elprice_step = (elprice_high-elprice_low)/steps;
gasprice_step = (gasprice_high-gasprice_low)/steps;

if (run_new_simulation)
    for electricity_price = elprice_low:elprice_step:elprice_high
        for gas_price = gasprice_low:gasprice_step:gasprice_high
            electricity_price_iter = electricity_price;
            gas_price_iter = gas_price;
            plant_opt_fmincon;
            save(['plantDesign_elgas' num2str(100000*electricity_price) num2str(100000*gas_price)],'p_size','fval','test_production_matrix');
        end
    end
end

plotnr = 0;
r = length(elprice_low:elprice_step:elprice_high);
c = length(gasprice_low:gasprice_step:gasprice_high);
row = 0;
col = 0;
for i = elprice_low:elprice_step:elprice_high
    row = row + 1;
    col = 0;
    for j = gasprice_low:gasprice_step:gasprice_high
        col = col + 1;
        plotnr = plotnr + 1;
        load(['plantDesign_elgas' num2str(100000*i) num2str(100000*j)]);
        if (plot_bargraphs)
            subplot(r,c,plotnr);
            bar(p_size(1:3),0.5);
            axis([0 4 0 6000]);
            xlabel(['Elprice = ' num2str(i) ' Gasprice = ' num2str(j)]);
        end
        plant_matrix_HP(row,col) = p_size(1);
        plant_matrix_EB(row,col) = p_size(2);
        plant_matrix_PB(row,col) = p_size(3);
        plant_matrix_cost(row,col) = fval;
    end
end
running_energy_price_simulation = 0;