% Script for showing the different designs of the plant at different
% electricity and gas prices

% -------------------------------------------------------
run_new_simulation = 0;
steps = 8; %number of steps in the simulation
% -------------------------------------------------------

global C_specific_HP
global C_specific_EB
global C_specific_PB
global interest_rate
global co2_tax;

C_specific_HP_mid = C_specific_HP;
C_specific_HP_min = C_specific_HP_mid*0.5;
C_specific_HP_max = C_specific_HP_mid*1.5;
C_specific_HP_step = (C_specific_HP_mid-C_specific_HP_min)/(steps/2);

C_specific_EB_mid = C_specific_EB;
C_specific_EB_min = C_specific_EB_mid*0.5;
C_specific_EB_max = C_specific_EB_mid*1.5;
C_specific_EB_step = (C_specific_EB_mid-C_specific_EB_min)/(steps/2);

C_specific_PB_mid = C_specific_PB;
C_specific_PB_min = C_specific_PB_mid*0.5;
C_specific_PB_max = C_specific_PB_mid*1.5;
C_specific_PB_step = (C_specific_PB_mid-C_specific_PB_min)/(steps/2);

interest_rate_mid = interest_rate;
interest_rate_min = interest_rate_mid*0.5;
interest_rate_max = interest_rate_mid*1.5;
interest_rate_step = (interest_rate_mid-interest_rate_min)/(steps/2);

co2_tax_mid = co2_tax;
co2_tax_min = co2_tax_mid*0.5;
co2_tax_max = co2_tax_mid*1.5;
co2_tax_step = (co2_tax_mid-co2_tax_min)/(steps/2);

if (run_new_simulation)
tic;
for specific_HP = C_specific_HP_min:C_specific_HP_step:C_specific_HP_max
    C_specific_HP = specific_HP;
    plant_opt_fmincon;
    save(['HP_C' num2str(specific_HP*1000)],'p_size','fval','test_production_matrix');
end

C_specific_HP = C_specific_HP_mid;

for specific_EB = C_specific_EB_min:C_specific_EB_step:C_specific_EB_max
    C_specific_EB = specific_EB;
    plant_opt_fmincon;
    save(['EB_C' num2str(specific_EB*1000)],'p_size','fval','test_production_matrix');
end

C_specific_EB = C_specific_EB_mid;

for specific_PB = C_specific_PB_min:C_specific_PB_step:C_specific_PB_max
    C_specific_PB = specific_PB;
    plant_opt_fmincon;
    save(['PB_C' num2str(specific_PB*1000)],'p_size','fval','test_production_matrix');
end


C_specific_PB = C_specific_PB_mid;

for interest_rate_iter = interest_rate_min:interest_rate_step:interest_rate_max
    interest_rate = interest_rate_iter;
    plant_opt_fmincon;
    save(['interest' num2str(100000*interest_rate_iter)],'p_size','fval','test_production_matrix');
end

interest_rate = interest_rate_mid;

for co2_tax_iter = co2_tax_min:co2_tax_step:co2_tax_max
    co2_tax = co2_tax_iter;
    plant_opt_fmincon;
    save(['co2_tax' num2str(100000*co2_tax_iter)],'p_size','fval','test_production_matrix');
end

co2_tax = co2_tax_mid;
toc;
end