% Function which calculates the operational cost per hour
% --------------------------------------------------------------------

function f = objecfun(x)
% x(1) = VPmax
% x(2) = EBmax
% x(3) = PBmax
global VPmax EBmax PBmax EL_PRICE PROPANE_PRICE source_active current_hour heat_pump_control_cost electrical_boiler_control_cost propane_burner_control_cost electricity_co2_emission gas_co2_emission co2_tax;
x(4) = max(1,VPmax);
x(5) = max(1,EBmax);
x(6) = max(1,PBmax);
x(7) = EL_PRICE;
x(8) = PROPANE_PRICE;

if(x(1) == 0)
    n_heat_pump = 1;
else
    n_heat_pump = heat_pump_efficiency(x(1)/x(4));
end
n_electrical_boiler = 0.98;
if(x(3) == 0)
    n_propane_burner = 1;
else
    n_propane_burner = propane_burner_efficiency(x(3)/x(6));
end

f = x(1)*(x(7)+electricity_co2_emission*co2_tax)/n_heat_pump;
%f = f + heat_pump_control_cost*abs(source_active(current_hour,1)-(x(1)>0));

f = f + x(2)*(x(7)+electricity_co2_emission*co2_tax)/n_electrical_boiler;
%f = f + electrical_boiler_control_cost*abs(source_active(current_hour,2)-(x(2)>0));

f = f + x(3)*(x(8)+gas_co2_emission*co2_tax)/n_propane_burner;
%f = f + propane_burner_control_cost*abs(source_active(current_hour,2)-(x(3)>0));

end