% Script which finds the optimal design of the heat generation plant
% ----------------------------------------------------------------------

global power_demand
global heat_pump_part_load_limit
global electrical_boiler_part_load_limit
global propane_burner_part_load_limit
global failsafe_power_supply_factor;
global heat_pump_max_limit;
global electrical_boiler_max_limit;
global propane_burner_max_limit;
global storage_status;

x0 = [0.5*max(power_demand)*heat_pump_max_limit 0.5*max(power_demand)*electrical_boiler_max_limit 0.5*max(power_demand)*propane_burner_max_limit 0 0 0]; % Start points
A = [-1 0 0 1 0 0; ...
    0 -1 0 0 1 0; ...
    0 0 -1 0 0 1; ...
    -1 -1 -1 0 0 0; ...
%     heat_pump_part_load_limit 0 0 -1 0 0;...
%     0 electrical_boiler_part_load_limit 0 0 -1 0; ...
%     0 0 propane_burner_part_load_limit 0 0 -1; ...
    -1 -1 0 0 0 0;-1 0 -1 0 0 0;0 -1 -1 0 0 0];
b = [0; ...
    0; ...
    0; ...
    -max(power_demand)*1.2; ...
%     0; ...
%     0; ...
%     0; ...
    -max(power_demand)*failsafe_power_supply_factor; ...
    -max(power_demand)*failsafe_power_supply_factor; ...
    -max(power_demand)*failsafe_power_supply_factor];
Ax = [heat_pump_part_load_limit 0 0 -1 0 0;...
    0 electrical_boiler_part_load_limit 0 0 -1 0; ...
    0 0 propane_burner_part_load_limit 0 0 -1];
bx = [0 0 0];
lb = [0 0 0 0 0 0];
ub = [max(power_demand)*heat_pump_max_limit*1.2 max(power_demand)*electrical_boiler_max_limit*1.2 max(power_demand)*propane_burner_max_limit*1.2 max(power_demand) max(power_demand) max(power_demand)];
tic
options = optimset('Display','off');
%options = optimset('Display','iter','PlotFcns','optimplotx','PlotFcns','optimplotfval');
[p_size,fval] = fmincon(@plant_operation,x0,A,b,Ax,bx,lb,ub,[],options);
toc;